

#define MIO_LISTEN_RAW 	1
#define MIO_CONNECT_RAW 2
#define MIO_LISTEN_XML	3
#define MIO_CONNECT_XML	4

typedef enum { state_ACTIVE, state_CLOSE } mio_state;
typedef enum { type_LISTEN, type_NORMAL, type_NUL, type_HTTP } mio_type;

/* callback state flags */
#define MIO_NEW       0
#define MIO_BUFFER    1
#define MIO_XML_ROOT  2
#define MIO_XML_NODE  3 
#define MIO_CLOSED    4
#define MIO_ERROR     5

typedef struct mio_st
{
    pool p;
    int fd;
    mio_type type; /* listen (server) socket or normal (client) socket */
    mio_state state;

    void *cb_arg;    /* do not modify directly */
    void *cb;     /* do not modify directly */

    char *ip;
    int port;
    int timeout;
    GIOChannel *gio;
    GMutex *gio_lock;
    guint watch_source;
} *mio, _mio;

/* standard i/o callback function definition */
typedef void (*mio_std_cb)(mio m, int state, void *arg);
typedef void (*mio_xml_cb)(mio m, int state, void *arg, xmlnode x);
typedef void (*mio_raw_cb)(mio m, int state, void *arg, char *buffer,int bufsz);

